<?php
/**
 * abstract class for payment/shipment plugins
 *  
 * PerfectMoneyForVirtueMart Payment Plugin
 *   
 * @author SoftPill.Eu
 * @link http://www.softpill.eu
 * @copyright Copyright (c) 2013 SoftPill.Eu. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.txt
 * This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version 1.0 Nov 2013
 */

ini_set("display_errors",0);
error_reporting(E_ALL);

defined('_JEXEC') or die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');

if (!class_exists('vmPSPlugin')) {
    require(JPATH_VM_PLUGINS . DS . 'vmpsplugin.php');
}

class plgVmPaymentPerfectMoneyForVirtueMart extends vmPSPlugin {

    // instance of class
    public static $_this = FALSE;

    function __construct(& $subject, $config) {
  		parent::__construct($subject, $config);
  		
  		$this->_loggable = true;
  		$this->tableFields = array_keys($this->getTableSQLFields());
  		$this->_tablepkey = 'id'; 
  		$this->_tableId = 'id'; 
  		$varsToPush = $this->getVarsToPush();
  		$this->setConfigParameterable($this->_configTableFieldName, $varsToPush);
  	}

    public function getVmPluginCreateTableSQL() {
        return $this->createTableSQL('Payment perfectmoney Table');
    }

    function getTableSQLFields() {
        $SQLfields = array(
            'id' => 'int(11) UNSIGNED NOT NULL AUTO_INCREMENT',
            'virtuemart_order_id' => 'int(1) UNSIGNED',
            'order_number' => 'char(64)',
            'virtuemart_paymentmethod_id' => 'mediumint(1) UNSIGNED',
            'payment_name' => 'varchar(5000)',
            'payment_order_total' => 'decimal(15,5) NOT NULL DEFAULT \'0.00000\'',
            'payment_currency' => 'char(3) ',
            'cost_per_transaction' => 'decimal(10,2)',
            'cost_percent_total' => 'decimal(10,2)',
            'tax_id' => 'smallint(1)',
        );
        return $SQLfields;
    }
    function setParams($param_array,$comp_name)
    {
      if ( count($param_array) > 0 )
      {
        jimport('joomla.version');
        $jver = new JVersion();
        $jversion=$jver->getShortVersion();
        $joomla_ver=2;
        if(version_compare($jversion,'2.5','<'))
        {
          $joomla_ver=1;
        }
        if($joomla_ver==1)
        {
          $db = JFactory::getDbo();
          $params1=$this->getParams($comp_name);
          foreach ( $param_array as $name => $value )
          {
            $params1[ (string) $name ] = (string) $value;
          }
          $params="";
          foreach ( $params1 as $name => $value )
          {
            $params.=$name."=".$value."\n";
          }
          $db->setQuery('UPDATE #__plugins SET params = ' .
          $db->quote( $params ) .
          ' WHERE element = '.$db->quote($comp_name));
          $db->query();
        }
        else
        {
          $db = JFactory::getDbo();
          $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
          $params1 = json_decode( $db->loadResult(), true );
          foreach ( $param_array as $name => $value )
          {
            $params1[ (string) $name ] = (string) $value;
          }
          $params1String = json_encode( $params1 );
          $db->setQuery('UPDATE #__extensions SET params = ' .
          $db->quote( $params1String ) .
          ' WHERE element = '.$db->quote($comp_name));
          $db->query();
        }
      }
    }
    function getParams($comp_name)
    {
      jimport('joomla.version');
      $jver = new JVersion();
      $jversion=$jver->getShortVersion();
      $joomla_ver=2;
      if(version_compare($jversion,'2.5','<'))
      {
        $joomla_ver=1;
      }
      if($joomla_ver==1)
      {
        $params1=array();
        $db = JFactory::getDbo();
        $db->setQuery('SELECT params FROM #__plugins WHERE element = '.$db->quote($comp_name));
        $params=$db->loadResult();
        
        if($params!="")
        {
          $tarr=explode("\n",$params);
        }
        if(count($tarr)>0)
        {
          foreach($tarr as $p)
          {
            if($p!="")
            {
              $pos = strpos($p, "=");
              if ($pos === false) {}
              else
              {
                $key=substr($p,0,$pos);
                $val=substr($p,($pos+1),strlen($p));
                $params1[$key]=$val;
              }
            }
          }
        }
        return $params1;
      }
      else
      {
        $db = JFactory::getDbo();
        $db->setQuery('SELECT params FROM #__extensions WHERE element = '.$db->quote($comp_name));
        $params1 = json_decode( $db->loadResult(), true );
        return $params1;
      }
    }
  	function checkLicense($lic)
    {
      $checkurl='http://www.softpill.eu/check_complic.php?comp=perfectmoneyforvirtuemart&h='.str_ireplace("www.","",$_SERVER['HTTP_HOST']).'&lic='.$lic;
      if (!function_exists('curl_init'))
      {
        $output=@file_get_contents($checkurl);
        if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
        {
          $ok = 1;
        }
      }
      else
      {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $checkurl);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        $output = curl_exec($ch);
        curl_close($ch);
        if($output==str_ireplace("www.","",$_SERVER['HTTP_HOST']))
        {
          $ok = 1;
        }
      }
    
      
      $application = JFactory::getApplication();
      if(@$ok==1)
      {
        $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
        $this->setParams(array('dchk'=>$chk,'perfectmoneylic'=>$lic),'perfectmoneyforvirtuemart');
        $application->enqueueMessage('Thank You for Activating your PerfectMoney - Payment Gateway', 'success');
        return 1;
      }
      else
      {
        $this->setParams(array('perfectmoneylic'=>'','dchk'=>''),'perfectmoneyforvirtuemart');
        $application->enqueueMessage('Provided License code for PerfectMoney is wrong', 'error');
        return 0;
      }
    }
    function plgVmConfirmedOrder($cart, $order) {
      $params1  = $this->getParams('perfectmoneyforvirtuemart');
      $dchk=$params1['dchk'];
      $lic=$params1['perfectmoneylic'];
      $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
      if($dchk!=$chk)
      {
        $application = JFactory::getApplication();
        if($lic=="")
        {
          $application->enqueueMessage('Please input your PerfectMoney - Payment Gateway License Code', 'error');
          $this->setParams(array('perfectmoneylic'=>'','dchk'=>''),'perfectmoneyforvirtuemart');
          return;
        }
        else
        {
          $dchk=@$params1['dchk'];
          if($dchk=='')
          {
            if(!$this->checkLicense($lic))
            {
              return;
            }
          }
          else
          {
            $chk=md5($lic.str_ireplace("www.","",$_SERVER['HTTP_HOST']));
            if($chk!=$dchk)//check
            {
              $this->setParams(array('perfectmoneylic'=>'','dchk'=>''),'perfectmoneyforvirtuemart');
              $application->enqueueMessage('Provided License code for PerfectMoney is wrong', 'error');
              return;
            }
          }
        }
      }
        if (!($method = $this->getVmPluginMethod($order['details']['BT']->virtuemart_paymentmethod_id))) {
            return NULL; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return FALSE;
        }
        $session = JFactory::getSession();
        $this->logInfo('plgVmConfirmedOrder order number: ' . $order['details']['BT']->order_number, 'message');

        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }
        if (!class_exists('VirtueMartModelCurrency')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'currency.php');
        }

        $address = ((isset($order['details']['ST'])) ? $order['details']['ST'] : $order['details']['BT']);

        if (!class_exists('TableVendors')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'table' . DS . 'vendors.php');
        }

        $vendorModel = VmModel::getModel('Vendor');
        $vendorModel->setId(1);
        $vendor = $vendorModel->getVendor();
        $vendorModel->addImages($vendor, 1);
        $this->getPaymentCurrency($method);
        $currency_code_3 = shopFunctions::getCurrencyByID($method->payment_currency, 'currency_code_3');

        $paymentCurrency = CurrencyDisplay::getInstance($method->payment_currency);
        $totalInPaymentCurrency = round($paymentCurrency->convertCurrencyTo($method->payment_currency, $order['details']['BT']->order_total, FALSE), 2);
        $cd = CurrencyDisplay::getInstance($cart->pricesCurrency);
        if ($totalInPaymentCurrency <= 0) {
            vmInfo('Payment Amount not valid for PerfectMoney');
            return FALSE;
        }
        $merchant_account = $method->account;
        if (empty($merchant_account)) {
            vmInfo('PerfectMoney Merchant Account ID is not set. Please configure this parameter in your PerfectMoney payment method.');
            return FALSE;
        }
        $merchant_password = $method->password;
        if (empty($merchant_password)) {
            vmInfo('PerfectMoney Merchant Alternate Passphrase is not set. Please configure this parameter in your PerfectMoney payment method.');
            return FALSE;
        }
        $products_arr=array();
        $products_names=array();
        $cnt=0;
        foreach($order['items'] as $product)
        {
          $cnt++;
          $products_arr['product'.$cnt]=$product->order_item_name."x".$product->product_quantity;
          $products_names[]='product'.$cnt;
        }
        
        $dbValues['order_number'] = $order['details']['BT']->order_number;
        $dbValues['payment_name'] = $this->renderPluginName($method, $order);
        $dbValues['virtuemart_paymentmethod_id'] = $cart->virtuemart_paymentmethod_id;
        $dbValues['payment_currency'] = $method->payment_currency;
        $dbValues['payment_order_total'] = $totalInPaymentCurrency;
        $dbValues['cost_per_transaction'] = $method->cost_per_transaction;
    		$dbValues['cost_percent_total'] = $method->cost_percent_total;
    		$dbValues['tax_id'] = $method->tax_id;
        $this->storePSPluginInternalData($dbValues);
        $config =& JFactory::getConfig();
        $url = 'https://perfectmoney.is/api/step1.asp';
        $post_variables=array(
        "PAYMENT_ID"=>$order['details']['BT']->order_number,
        "PAYEE_ACCOUNT"=>$merchant_account,
        "PAYEE_NAME"=>$config->getValue( 'config.sitename' ),
        "PAYMENT_AMOUNT"=>$totalInPaymentCurrency,
        "PAYMENT_UNITS"=>$currency_code_3,
        "STATUS_URL"=>JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginnotification&tmpl=component&order_id=' . $order['details']['BT']->order_number),
        "PAYMENT_URL"=>JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginresponsereceived&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id . '&Itemid=' . JRequest::getInt('Itemid')),
        "NOPAYMENT_URL"=>JROUTE::_(JURI::root() . 'index.php?option=com_virtuemart&view=pluginresponse&task=pluginUserPaymentCancel&on=' . $order['details']['BT']->order_number . '&pm=' . $order['details']['BT']->virtuemart_paymentmethod_id . '&Itemid=' . JRequest::getInt('Itemid')),
        "BAGGAGE_FIELDS"=>implode(' ',$products_names),
        "FORCED_PAYMENT_METHOD"=>"account"
        );
        foreach($products_arr as $name => $val)
        {
          $post_variables[$name]=$val;
        }
        $html = '<html><head><title>Redirection</title></head><body><div style="margin: auto; text-align: center;">';
        $html .= '<form action="' . $url . '" method="post" name="vm_perfectmoney_form">';
        $html .= '<input type="submit"  value="Click here to Pay" />';
        foreach ($post_variables as $name => $value) {
    			$html .= '<input type="hidden" name="' . $name . '" value="' . htmlspecialchars ($value) . '" />';
    		}
        $html .= '</form></div>';
        $html .= ' <script type="text/javascript">';
        $html .= ' document.vm_perfectmoney_form.submit();';
        $html .= ' </script></body></html>';

        $cart->_confirmDone = FALSE;
        $cart->_dataValidated = FALSE;
        $cart->setCartIntoSession();
        JRequest::setVar('html', $html);
    }

    function plgVmgetPaymentCurrency($virtuemart_paymentmethod_id, &$paymentCurrencyId) {
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return NULL; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return FALSE;
        }
        $this->getPaymentCurrency($method);
        $paymentCurrencyId = $method->payment_currency;
    }

    function plgVmOnPaymentResponseReceived(&$html) {
        if (!class_exists('VirtueMartCart')) {
            require(JPATH_VM_SITE . DS . 'helpers' . DS . 'cart.php');
        }
        if (!class_exists('shopFunctionsF')) {
            require(JPATH_VM_SITE . DS . 'helpers' . DS . 'shopfunctionsf.php');
        }
        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }

        $virtuemart_paymentmethod_id = JRequest::getInt('pm', 0);
        $order_number = JRequest::getString('on', 0);
        $vendorId = 0;
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return NULL; // Another method was selected, do nothing
        }
        if (!$this->selectedThisElement($method->payment_element)) {
            return NULL;
        }

        if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
            return NULL;
        }
        if (!($paymentTable = $this->getDataByOrderId($virtuemart_order_id))) {
            return '';
        }
        $payment_name = $this->renderPluginName($method);
        $html = $this->_getPaymentResponseHtml($paymentTable, $payment_name);

        $cart = VirtueMartCart::getCart();
        $cart->emptyCart();
        return TRUE;
    }

    function plgVmOnUserPaymentCancel() {
        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }
        $order_number = JRequest::getString('on', '');
        $virtuemart_paymentmethod_id = JRequest::getInt('pm', '');
        if (empty($order_number) or empty($virtuemart_paymentmethod_id) or !$this->selectedThisByMethodId($virtuemart_paymentmethod_id)) {
            return NULL;
        }
        if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($order_number))) {
            return NULL;
        }
        if (!($method = $this->getVmPluginMethod($virtuemart_paymentmethod_id))) {
            return NULL; // Another method was selected, do nothing
        }
        $modelOrder = VmModel::getModel('orders');
        $order = array();
        vmInfo('Yo have canceled your PerfectMoney order.');
        $order['customer_notified'] = 1;
        $order['order_status'] = $method->status_canceled;
        $order['comments'] = '';
        $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
        return TRUE;
    }

    function plgVmOnPaymentNotification() {
        if (!class_exists('VirtueMartModelOrders')) {
            require(JPATH_VM_ADMINISTRATOR . DS . 'models' . DS . 'orders.php');
        }

        $order_number = $_GET['order_id'];
        if (!($virtuemart_order_id = VirtueMartModelOrders::getOrderIdByOrderNumber($_GET['order_id']))) {
            return NULL;
        }
        $vendorId = 0;
        if (!($payments = $this->getDatasByOrderId($virtuemart_order_id))) {
            return NULL;
        }
        $method = $this->getVmPluginMethod($payments[0]->virtuemart_paymentmethod_id);

        $merchant_account = $method->account;
        $merchant_password = $method->password;

        $perfectmoney_data = JRequest::get ('post');
        
        if (!$this->selectedThisElement($method->payment_element)) {
            return FALSE;
        }
        
        $this->logInfo('perfectmoney ' . implode('   ', $perfectmoney_data), 'message');
        $modelOrder = VmModel::getModel('orders');
        $order = array();
        $order['customer_notified'] = 1;
        $order['comments'] = '';
        $PAYEE_ACCOUNT=$perfectmoney_data['PAYEE_ACCOUNT'];
        $PAYMENT_ID=$perfectmoney_data['PAYMENT_ID'];
        $PAYMENT_AMOUNT=$perfectmoney_data['PAYMENT_AMOUNT'];
        $PAYMENT_UNITS=$perfectmoney_data['PAYMENT_UNITS'];
        $PAYMENT_BATCH_NUM=$perfectmoney_data['PAYMENT_BATCH_NUM'];
        $PAYER_ACCOUNT=$perfectmoney_data['PAYER_ACCOUNT'];
        $TIMESTAMPGMT=$perfectmoney_data['TIMESTAMPGMT'];
        $V2_HASH=$perfectmoney_data['V2_HASH'];
        
        $merchant_password_hash=strtoupper(md5($merchant_password));
        $hash="$PAYMENT_ID:$PAYEE_ACCOUNT:$PAYMENT_AMOUNT:$PAYMENT_UNITS:$PAYMENT_BATCH_NUM:$PAYER_ACCOUNT:$merchant_password_hash:$TIMESTAMPGMT";
        $hash=strtoupper(md5($hash));
        
        if($hash==$V2_HASH)
        {
          $order['order_status'] = $method->status_success;
        }
        else
        {
          $order['order_status'] = $method->status_canceled;
        }
        
        $this->logInfo('plgVmOnPaymentNotification return new_status:' . $order['order_status'], 'message');
        $modelOrder->updateStatusForOneOrder($virtuemart_order_id, $order, TRUE);
        exit;
    }

    /**
     * @param $virtuemart_order_id
     * @return mixed|string
     */
    function _getTablepkeyValue($virtuemart_order_id) {

        $db = JFactory::getDBO();
        $q = 'SELECT ' . $this->_tablepkey . ' FROM `' . $this->_tablename . '` '
                . 'WHERE `virtuemart_order_id` = ' . $virtuemart_order_id;
        $db->setQuery($q);

        if (!($pkey = $db->loadResult())) {
            JError::raiseWarning(500, $db->getErrorMsg());
            return '';
        }
        return $pkey;
    }

    function _getPaymentResponseHtml($paymentTable, $payment_name) {
        $db = &JFactory::getDBO();
        $query="select order_pass from #__virtuemart_orders where order_number='".$paymentTable->order_number."'";
        $db->setQuery($query);
        $result=$db->loadObject();
        
    		$html = '<table>' . "\n";
    		$html .= '<tr><td>Payment Name</td><td>'.$payment_name.'</td></tr>';
    		$html .= '<tr><td>Order Number</td><td>'.$paymentTable->order_number.'</td></tr>';
    		
        if(isset($result->order_pass))
        {
          $html .= '<tr><td>View Order</td><td><a href="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'">Click here</a></td></tr>';
        }
        
        $html .= '</table>
        ' . "\n";
        if(isset($result->order_pass))
        {
          $html .= '
          <script type="text/javascript">
          alert("Thank You!");
          window.location="'.JURI::base().'index.php?option=com_virtuemart&view=orders&layout=details&order_number='.$paymentTable->order_number.'&order_pass='.$result->order_pass.'";
          </script>
          ';
        }
    		return $html;
    }

    function getCosts(VirtueMartCart $cart, $method, $cart_prices) {
        if (preg_match('/%$/', $method->cost_percent_total)) {
            $cost_percent_total = substr($method->cost_percent_total, 0, -1);
        } else {
            $cost_percent_total = $method->cost_percent_total;
        }
        return ($method->cost_per_transaction + ($cart_prices['salesPrice'] * $cost_percent_total * 0.01));
    }

    protected function checkConditions($cart, $method, $cart_prices) {
        return true;
    }


    /**
     * Create the table for this plugin if it does not yet exist.
     * This functions checks if the called plugin is active one.
     * When yes it is calling the standard method to create the tables
     */
    function plgVmOnStoreInstallPaymentPluginTable($jplugin_id) {
        return $this->onStoreInstallPluginTable($jplugin_id);
    }

    /**
     * This event is fired after the payment method has been selected. It can be used to store
     * additional payment info in the cart.
     */
    public function plgVmOnSelectCheckPayment(VirtueMartCart $cart, &$msg) {
        return $this->OnSelectCheck($cart);
    }

    /**
     * plgVmDisplayListFEPayment
     * This event is fired to display the pluginmethods in the cart (edit shipment/payment) for exampel
     */
    public function plgVmDisplayListFEPayment(VirtueMartCart $cart, $selected = 0, &$htmlIn) {
        return $this->displayListFE($cart, $selected, $htmlIn);
    }

    /*
     * plgVmonSelectedCalculatePricePayment
     * Calculate the price (value, tax_id) of the selected method
     * It is called by the calculator
     * This function does NOT to be reimplemented. If not reimplemented, then the default values from this function are taken.
     */

    public function plgVmonSelectedCalculatePricePayment(VirtueMartCart $cart, array &$cart_prices, &$cart_prices_name) {
        return $this->onSelectedCalculatePrice($cart, $cart_prices, $cart_prices_name);
    }

    /**
     * plgVmOnCheckAutomaticSelectedPayment
     * Checks how many plugins are available. If only one, the user will not have the choice. Enter edit_xxx page
     * The plugin must check first if it is the correct type
     */
    function plgVmOnCheckAutomaticSelectedPayment(VirtueMartCart $cart, array $cart_prices = array(), &$paymentCounter) {
        return $this->onCheckAutomaticSelected($cart, $cart_prices, $paymentCounter);
    }

    /**
     * This method is fired when showing the order details in the frontend.
     * It displays the method-specific data.
     */
    public function plgVmOnShowOrderFEPayment($virtuemart_order_id, $virtuemart_paymentmethod_id, &$payment_name) {
        $this->onShowOrderFE($virtuemart_order_id, $virtuemart_paymentmethod_id, $payment_name);
    }

    /**
     * This method is fired when showing when priting an Order
     * It displays the the payment method-specific data.
     */
    function plgVmonShowOrderPrintPayment($order_number, $method_id) {
        return $this->onShowOrderPrint($order_number, $method_id);
    }

    /**
     * This method is fired when showing the order details in the frontend, for every orderline.
     * It can be used to display line specific package codes, e.g. with a link to external tracking and
     * tracing systems
     */
    function plgVmDeclarePluginParamsPayment($name, $id, &$data) {
        return $this->declarePluginParams('payment', $name, $id, $data);
    }

    function plgVmSetOnTablePluginParamsPayment($name, $id, &$table) {
        return $this->setOnTablePluginParams($name, $id, $table);
    }

}

// No closing tag
